// $Id: select_generators.h,v 1.3 2001/11/26 23:05:21 rwgk Exp $
/* Copyright (c) 2001 The Regents of the University of California through
   E.O. Lawrence Berkeley National Laboratory, subject to approval by the
   U.S. Department of Energy. See files COPYRIGHT.txt and
   cctbx/LICENSE.txt for further details.

   Revision history:
     2001 Sep 10: created from fragments in type.cpp, seminvariant.cpp (rwgk)
 */

#ifndef CCTBX_SGTBX_SELECT_GENERATORS_H
#define CCTBX_SGTBX_SELECT_GENERATORS_H

#include <cctbx/sgtbx/groups.h>

namespace cctbx { namespace sgtbx {
  namespace detail {

    struct AnyGenerators {
      AnyGenerators() : nGen(0) {}
      AnyGenerators(const SpaceGroup& SgOps);
      int nAll() const {
        if (ZInvT.isValid()) return nGen + 1;
        return nGen;
      }
      void setPrimitive();
      ChOfBasisOp Z2POp;
      TrVec ZInvT;
      TrVec PInvT;
      int nGen;
      RTMx ZGen[2];
      RTMx PGen[2];
    };

    struct StdGenerators: AnyGenerators {
      StdGenerators(const SpaceGroup& WorkSgOps,
                    const tables::MatrixGroup::Code& PG_MGC);
    };

  } // namespace detail
}} // namespace cctbx::sgtbx

#endif // CCTBX_SGTBX_SELECT_GENERATORS_H
