// $Id: neutronmodule.cpp,v 1.3 2001/11/26 23:05:21 rwgk Exp $
/* Copyright (c) 2001 The Regents of the University of California through
   E.O. Lawrence Berkeley National Laboratory, subject to approval by the
   U.S. Department of Energy. See files COPYRIGHT.txt and
   cctbx/LICENSE.txt for further details.

   Revision history:
     Apr 2001: SourceForge release (R.W. Grosse-Kunstleve)
 */

#include <boost/python/class_builder.hpp>
#include <cctbx/eltbx/basic.h>
#include <cctbx/eltbx/neutron.h>

using namespace cctbx;
using namespace cctbx::eltbx;

BOOST_PYTHON_MODULE_INIT(neutron)
{
  try
  {
#   include <cctbx/basic/from_bpl_import.h>

    python::module_builder this_module("neutron");

    const std::string Revision = "$Revision: 1.3 $";
    this_module.add(ref(to_python(
        Revision.substr(11, Revision.size() - 11 - 2))), "__version__");

    class_builder<NeutronNews1992Record>
    py_NeutronNews1992Record(this_module, "NeutronNews1992Record");

    py_NeutronNews1992Record.def(constructor<>());
    py_NeutronNews1992Record.def(constructor<const std::string&>());
    py_NeutronNews1992Record.def(constructor<const std::string&, bool>());
    py_NeutronNews1992Record.def(&NeutronNews1992Record::Symbol, "Symbol");
    py_NeutronNews1992Record.def(&NeutronNews1992Record::BoundCohScattLength,
      "BoundCohScattLength");
    py_NeutronNews1992Record.def(&NeutronNews1992Record::AbsCrossSect,
      "AbsCrossSect");
  }
  catch(...)
  {
    boost::python::handle_exception(); // Deal with the exception for Python
  }
}
